/**
 * @author THINKER
 */

var defaultPath = window.location.pathname;
var $savedPage;

function initPage(){
	

	$("#container").prepend("<div class='section tempPage'>Temp Page</div>");
	var $spinner = $("<div class='spinner'><img src='img/spinner.gif' alt=''/><h2>loading.....</h2></div>");
	$spinner.appendTo("#container");

	
}


function loadPage(transType, targetPage, backFlag, nextHistoryType){
	
	$(".spinner").addClass('show');
	
	if($savedPage){
		$savedPage.appendTo('.container');
	}
	
	
	var idx= 0; 
	if(idx = targetPage.lastIndexOf('/') > 0 ){
		targetPage = targetPage.substr(idx);
	}
	
	console.log(targetPage);	

	//history api
	if(!backFlag){
		//자신이 어떻게 이동했는지를 기록해 둔다. 
		var pstate = {toPage:targetPage, type:transType};
		window.history.pushState(pstate,"",targetPage);
		
	}
	
	if(targetPage.indexOf("#")== 0){
		
		$(".tempPage").load(defaultPath + " "+ targetPage+" > *", 
		  function(){
			  transitionPage($(".tempPage"), transType, backFlag , nextHistoryType);
			  $savedPage = $(targetPage);
			  $(targetPage).remove();
		  }
		);	
		
	}else {
	

		$(".tempPage").load(targetPage +" .currentPage > *", 
		  function(){
			  transitionPage($(".tempPage"), transType, backFlag , nextHistoryType);
		  }
		);		
	}
}


function transitionPage($next, type, backFlag, nextHistoryType){
	
	if(!type){
		type="fade";
	}
	
	if(!backFlag){
		backFlag = '';
	}
	
	console.log("type: " +(type+backFlag));

	$before = $('.current');
	
	$before.addClass(type+backFlag+'-out');	
	$next.addClass('current '+type+backFlag+'-in');

	$next.one("webkitAnimationEnd", function( ) {
		 $before.removeClass(type+backFlag+"-out current").addClass('tempPage').html("");
		 $next.removeClass(type+backFlag+'-in tempPage');
		 
		 type = nextHistoryType?nextHistoryType:type;
		 $next.attr("data-change-type", type);
		  
		 $(".spinner").removeClass('show');	
	});	
	
}



window.addEventListener("popstate", function(e) {
	
	if(!e.state){		
		
		var tempState = {toPage:"loadTrans05.html", type:'flip'};
		window.history.replaceState(tempState,"", tempState.toPage);

				
		return;
	}
	
	var beforePage = e.state.toPage;
	
	console.log("popstate: "+beforePage +" : " + e.state.type);
	
	var changeType = $('.current').attr("data-change-type");
	var nextHistoryType = e.state.type;
	
	console.log("popstate: "+beforePage +" : " + changeType);
	loadPage(changeType, beforePage, '-back', nextHistoryType);

}, false);

