/**
 * @author THINKER
 */

var defaultPath = window.location.pathname;
var $savedPage, pageBefore, pageAfter;

function initPage(){

	$("#container").prepend("<div class='section tempPage'>Temp Page</div>");
	
	var $spinner = $("<div class='spinner'><img src='img/spinner.gif' alt=''/><h2>loading.....</h2></div>");
	$spinner.appendTo("#container");
			
	
}


function loadPage(transType, targetPage, backFlag, nextHistoryType){
	
	$(".spinner").addClass('show');
	
	if($savedPage){
		$savedPage.appendTo('.container');
	}
	
	
	var idx= 0; 
	if(idx = targetPage.lastIndexOf('/') > 0 ){
		targetPage = targetPage.substr(idx);
	}
	
	console.log(targetPage);	

	//history api
	if(!backFlag){
		//자신이 어떻게 이동했는지를 기록해 둔다. 
		var pstate = {toPage:targetPage, type:transType};
		window.history.pushState(pstate,"",targetPage);
		
	}
	
	if(targetPage.indexOf("#")== 0){
		
		$(".tempPage").load(defaultPath + " "+ targetPage+" > *", 
		  function(){  
			var jsFileURL = "js/"+targetPage.substr(1)+".js";
			$.getScript(jsFileURL)
			.done(function(data, textStatus){
				if(textStatus == 'success' && pageBefore){
					pageBefore();
				}
				transitionPage($(".tempPage"), transType, backFlag , nextHistoryType , pageAfter);
			})//done	
			.fail(function( ){
				transitionPage($(".tempPage"), transType, backFlag , nextHistoryType);
			});
		  }
		);	
		
	}else {
	

		$(".tempPage").load(targetPage +" .currentPage > *", 
		  function(){
			var jsFileURL = "js/"+targetPage.substr(0,targetPage.lastIndexOf("."))+".js";
			$.getScript(jsFileURL)
			.done(function(data, textStatus){
				if(textStatus == 'success' && pageBefore ){
					pageBefore();
				}
			  	transitionPage($(".tempPage"), transType, backFlag , nextHistoryType , pageAfter);
			})//done
			.fail(function( ) {
				transitionPage($(".tempPage"), transType, backFlag , nextHistoryType);
			 })//fail
		  }
		);		
	}	

}


function transitionPage($next, type, backFlag, nextHistoryType , pageAfter){
	
	if(!type){
		type="fade";
	}
	
	if(!backFlag){
		backFlag = '';
	}
	
	console.log("type: " +(type+backFlag));

	$before = $('.current');
	
	$before.addClass(type+backFlag+'-out');	
	$next.addClass('current '+type+backFlag+'-in');

	$next.one("webkitAnimationEnd", function( ) {
		 $before.removeClass(type+backFlag+"-out current").addClass('tempPage').html("");
		 $next.removeClass(type+backFlag+'-in tempPage');
		 
		 type = nextHistoryType?nextHistoryType:type;
		 $next.attr("data-change-type", type);
		 
		 if(pageAfter){
		 	pageAfter();
		 	pageAfter = null;
		 }
		  
		 $(".spinner").removeClass('show');	
	});	
	
}



window.addEventListener("popstate", function(e) {
	
	if(!e.state){		
		
		var tempState = {toPage:"#section1", type:'flip'};
		window.history.replaceState(tempState,"", "loadTrans08.html");

				
		return;
	}
	
	var beforePage = e.state.toPage;
	
	console.log("popstate: "+beforePage +" : " + e.state.type);
	
	var changeType = $('.current').attr("data-change-type");
	var nextHistoryType = e.state.type;
	
	console.log("popstate: "+beforePage +" : " + changeType);
	loadPage(changeType, beforePage, '-back', nextHistoryType);

}, false);

