/**
 * @author THINKER
 */
function changePage($next, effect){
	

	var pstate = {toPage:'#'+$next.attr('id')};
	window.history.pushState(pstate,"",'#'+$next.attr('id'));
	
	transitionPage($next, effect);
}


window.addEventListener("popstate", function(e) {
	if(!e.state){
		var tempState = {toPage:'#'+$('.current').attr('id')};
		window.history.replaceState(tempState,"", tempState.toPage);
		return;
	}

	var toObj = $(e.state.toPage);
	console.log("back to:"+e.state.toPage);
	
	var backEffect = toObj.attr("data-change-type");
	if(!backEffect){
		backEffect ='slide';
	}
	console.log("back effect:" + backEffect );

	transitionPage($(e.state.toPage), backEffect , true);
	
}, false);


function transitionPage($next , effect , backFlag){
	
	var $before = $('.current');
	
	$before.attr("data-change-type" , effect);
	
	if($before.attr("id") == $next.attr("id")){
		return;
	}
	
	if(backFlag){
		effect +='-back';
	}
	
	$before.addClass(effect+'-out');	
	$next.addClass('current '+effect+'-in');

	$next.one("webkitAnimationEnd", function( ) {
		 $before.removeClass("current "+effect+"-out");
		 $next.removeClass(effect+'-in'); 
	});
}